<table mat-table [dataSource]="dataSource" class="mat-elevation-z8" *ngIf="dataSource.length > 0">

  <!--- Note that these columns can be defined in any order.
        The actual rendered columns are set as a property on the row definition" -->

  <ng-container matColumnDef="username">
    <th mat-header-cell *matHeaderCellDef> Username </th>
    <td mat-cell *matCellDef="let element"> {{element.username}} </td>
  </ng-container>

  <ng-container matColumnDef="firstName">
    <th mat-header-cell *matHeaderCellDef> First Name </th>
    <td mat-cell *matCellDef="let element"> {{element.firstName}} </td>
  </ng-container>

  <ng-container matColumnDef="lastName">
    <th mat-header-cell *matHeaderCellDef> Last Name </th>
    <td mat-cell *matCellDef="let element"> {{element.lastName}} </td>
  </ng-container>

  <ng-container matColumnDef="roles">
    <th mat-header-cell *matHeaderCellDef> Role </th>
    <td mat-cell *matCellDef="let element"> {{element.roles[0]}} </td>
  </ng-container>

  <ng-container matColumnDef="email">
    <th mat-header-cell *matHeaderCellDef> Email </th>
    <td mat-cell *matCellDef="let element"> {{element.email}} </td>
  </ng-container>

  <ng-container matColumnDef="edit">
    <th mat-header-cell *matHeaderCellDef></th>
    <td mat-cell *matCellDef="let element" (click)="editUser(element)"  matTooltip="Edit user" matTooltipPosition="before">
      <i class="fa fa-user-edit cursorPointer" data-toggle="modal" data-target="#user-edit-modal" data-backdrop="static" *ngIf="canEditRoles(element.roles[0])"
                                                                          data-keyboard="false"></i></td>
  </ng-container>

  <ng-container matColumnDef="delete">
    <th mat-header-cell *matHeaderCellDef></th>
    <td mat-cell *matCellDef="let element" (click)="deleteUser(element)" matTooltip="Delete user" matTooltipPosition="before">
      <i class="fa fa-trash-alt cursorPointer showDeleteUserPopupBtn" *ngIf="canDeleteRoles(element.roles[0])"></i></td>
  </ng-container>

  <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
  <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>
</table>

<app-alert-popup [usernameToDelete]="usernameToDelete" (confirmedDeletingUser)="deleteUserConfirmed($event)"></app-alert-popup>

<div class="plusIcon" *ngIf="SUBJECT.USER| can:ACTIONS.WRITE">
  <a href="#" data-toggle="modal" data-target="#user-create-modal" data-backdrop="static" data-keyboard="false"  onclick="return false;" (click)="openModal();" class="btn-floating btn-lg red waves-effect waves-light plus"><i class="fa fa-plus"></i></a>
</div>

<app-user-create-form [roles]="roles" [isBuildUserFormInitiated]="isBuildUserFormInitiated" (userDetailsEvent)="saveUser($event)"></app-user-create-form>

<app-user-edit-form [roles]="roles" [showCircularLoader]="showCircularLoaderInEditForm" [isUserUpdateSuccess]="isUserUpdateSuccess"
                    [userDetailsToEdit]="userDetailsToEdit" [isRoleEditable]="true" (userDetailsEvent)="updateUserDetails($event)"></app-user-edit-form>

<div *ngIf="showLoader">
  <app-loader></app-loader>
</div>

<div class="messagePopup deleteUserSuccessfully">
 {{actionResultMsg}}
</div>

<div class="messagePopup savedUserSuccessfully">
  {{actionResultMsg}}
</div>

<div class="messagePopup userUpdatedSuccessfully">
  User updated successfully
</div>
